<?php
/*
Plugin Name: WP Js List Pages Shortcodes
Plugin URI: http://www.joergschueler.de/dev/wp/list-pages-shortcodes/
Description: Support for [tree-pages], [list-pages] and [child-pages] shortcodes in your posts or pages to display all child and/or parent pages. The shortcodes accept all parameters available for <a href="http://codex.wordpress.org/Template_Tags/wp_list_pages">wp_list_pages()</a> function.
Author: Joerg Schueler
Version: 1.0
Author URI: http://www.joergschueler.de
*/

function list_pages_shortcode($atts, $content, $tag) {
	global $post;

	// defaults
	$def = array(
	    'class'       => $tag,
	    'depth'       => 0,
	    'show_date'   => '',
	    'date_format' => get_option('date_format'),
	    'exclude'     => '',
	    'child_of'    => 0,
	    'title_li'    => '',
	    'authors'     => '',
	    'sort_column' => 'menu_order, post_title',
	    'link_before' => '',
	    'link_after'  => '',
	    'exclude_tree'=> ''
	);

	$atts = shortcode_atts($def, $atts); // merge user params with defaults

	$atts['echo'] = 0; // set other params

         if($tag == 'tree-pages') {
		$ancestors = get_post_ancestors($post);
                 if (is_array($ancestors)) {
                 	$p = get_page(end($ancestors));
                         $parent = '<li class="page_item page-item-'.$p->ID.'"><a href="'.get_page_link($p->ID).'">'.$p->post_title.'</a>';
			$atts['child_of'] = $p->ID;
                 }
		$out = wp_list_pages($atts);
		if(!empty($out)) {
			$out = '<ul class="'.$atts['class'].'">' . $out . '</ul>';
                 }
                 if (is_array($ancestors)) {
                 	$out = '<ul class="'.$atts['class'].'">' . $parent . $out . '</li></ul>';
                 }
         } else {
         	if  ($tag == 'child-pages') {
			$atts['child_of'] = $post->ID;
		}
		$out = wp_list_pages($atts);
		if(!empty($out)) {
			$out = '<ul class="'.$atts['class'].'">' . $out . '</ul>';
                 }
         }

  return $out;
}

add_shortcode('tree-pages', 	'list_pages_shortcode');
add_shortcode('child-pages', 	'list_pages_shortcode');
add_shortcode('list-pages', 	'list_pages_shortcode');

?>